Unit QSL6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSL6R(var RINT :Real; var A :Real; var B :Real; F :Func_F1;
                var E :Real; var ALFA :Real; var BETA :Real;
                var XA :Real; var E1 :Real);

implementation

procedure QSL6R(var RINT :Real; var A :Real; var B :Real; F :Func_F1;
                var E :Real; var ALFA :Real; var BETA :Real;
                var XA :Real; var E1 :Real);
var
IL,U,V,X,BK :Integer;
RINT2,J1,J,K,L,M,C,D,TAU,O,BA,W,Z2,H,Z1,P,BH,BI,BJ,BF,BG,Q,R,S,E3,BB,
   BC,T,EPS,HM,E2 :Real;
MI,NI,Y,Z,NIS :Boolean;
KSI :Array [0..6] of Real;
BD :Array [0..2] of Real;
BY :Array [0..6] of Real;
AY :Array [0..6] of Real;
OM :Array [0..2] of Integer;
const
SYS059 :Real = 1.7E38;
C2EM10 :Real = 2.0E-10;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57,_58,_59,_60;
begin
{   DATA  FORTRAN  }
AY[0] := 0.02380952;
AY[1] := 0.2438095;
AY[2] := 0.02380952;
AY[3] := 0.1384130;
AY[4] := 0.2158727;
AY[5] := 0.2158727;
AY[6] := 0.1384130;
BY[0] := -0.07619047;
BY[1] := 0.2438095;
BY[2] := -0.07619047;
BY[3] := 0.1837020;
BY[4] := -0.2294162;
BY[5] := -0.2294162;
BY[6] := 0.1837020;
KSI[0] := 0.0;
KSI[1] := 0.5;
KSI[2] := 1.0;
KSI[3] := 0.08488805;
KSI[4] := 0.2655756;
KSI[5] := 0.7344244;
KSI[6] := 0.9151119;
NIS := ( A  > B );
if (  not ( (NIS) ) ) 
 then goto _1;
BA := A;
A := B;
B := BA;
_1:
V := 2;
Y := True;
X := 1;
C := 0.0;
EPS := E;
HM := C2EM10;
XA := -SYS059;
D := 0.0;
if ( BETA-ALFA ) < 0
 then goto _2
 else if ( BETA-ALFA ) > 0
       then goto _4
       else goto _3;
_2:
BA := ALFA;
ALFA := BETA;
BETA := BA;
goto _4;
_3:
ALFA := ALFA-HM;
BETA := BETA+HM;
_4:
if ( B-100.0 ) < 0
 then goto _7
 else if ( B-100.0 ) > 0
       then goto _5
       else goto _5;
_5:
if ( A+100.0 ) < 0
 then goto _6
 else if ( A+100.0 ) > 0
       then goto _35
       else goto _6;
_6:
Y := False;
X := -1;
K := B;
E := E/2;
B := A;
A := ALFA;
goto _35;
_7:
X := -1;
O := A;
A := B;
B := O;
goto _35;
_8:
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _9;
BA := A;
A := B;
B := BA;
_9:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _10;
E1 := 0.0;
J1 := 0.0;
goto _34;
_10:
MI := ( ALFA  < BETA  ) and ( (A  <= ALFA  ) and ( ALFA  < B  ) or ( A  < 
   BETA  ) and ( BETA  <= B) );
if (  not ( (MI) ) ) 
 then goto _12;
ALFA := (ALFA-A)/W;
BETA := (BETA-A)/W;
TAU := (BETA-ALFA)/2;
if ( TAU-HM ) < 0
 then goto _11
 else if ( TAU-HM ) > 0
       then goto _12
       else goto _11;
_11:
TAU := HM;
_12:
Z2 := E/W;
H := 1;
E1 := 0.0;
J1 := 0.0;
Z1 := EPS/W;
P := 0.0;
OM[0] := 0;
OM[1] := 0;
OM[2] := 0;
_13:
BH := P+H;
if (  not ( (MI) ) ) 
 then goto _14;
if (  not ( (P  < BETA  ) and ( BH  > ALFA  ) and ( H  > TAU) ) )
 then goto _14;
H := TAU;
if ( P  < ALFA ) 
 then H := ALFA-P;
if ( H  < TAU ) 
 then H := TAU;
_14:
BH := P+H;
BI := 0.0;
BJ := 0.0;
for BK:=1 to 3 do
 begin
  if ( OM[BK-1]  = 0 ) 
   then goto _15;
  BF := BD[BK-1];
  goto _16;
_15:
  BG := H*KSI[BK-1]+P;
  BD[BK-1] := F(W*BG+A);
  BF := BD[BK-1];
  OM[BK-1] := 1;
_16:
  BI := BI+AY[BK-1]*BF;
  BJ := BJ+BY[BK-1]*BF;
_17:
 end;
for BK:=4 to 7 do
 begin
  BG := H*KSI[BK-1]+P;
  BF := F(W*BG+A);
  BI := BI+AY[BK-1]*BF;
  BJ := BJ+BY[BK-1]*BF;
_18:
 end;
BI := H*BI;
BJ := Abs(H*BJ);
if ( BJ-Z1 ) < 0
 then goto _19
 else if ( BJ-Z1 ) > 0
       then goto _27
       else goto _27;
_19:
P := BH;
_20:
E1 := E1+BJ;
J1 := J1+BI;
BF := 1-P;
if ( 1.0+BF/64-1.0 ) < 0
 then goto _21
 else if ( 1.0+BF/64-1.0 ) > 0
       then goto _23
       else goto _21;
_21:
BG := Abs(F(B))+Abs(BD[2]);
BG := BG*BF;
if ( BG-Z2 ) < 0
 then goto _32
 else if ( BG-Z2 ) > 0
       then goto _22
       else goto _32;
_22:
E1 := E1+BG;
goto _32;
_23:
BD[0] := BD[2];
OM[1] := 0;
OM[2] := 0;
OM[0] := 1;
if ( BJ-Z1/IntPower(2,7) ) < 0
 then goto _24
 else if ( BJ-Z1/IntPower(2,7) ) > 0
       then goto _25
       else goto _25;
_24:
H := 2*H;
_25:
if ( H-BF ) < 0
 then goto _13
 else if ( H-BF ) > 0
       then goto _26
       else goto _13;
_26:
H := BF;
goto _13;
_27:
H := H/2;
if ( 64+H-64 ) < 0
 then goto _28
 else if ( 64+H-64 ) > 0
       then goto _31
       else goto _28;
_28:
if ( P ) < 0
 then goto _29
 else if ( P ) > 0
       then goto _30
       else goto _29;
_29:
if ( H/4 ) < 0
 then goto _30
 else if ( H/4 ) > 0
       then goto _31
       else goto _30;
_30:
XA := (P+A)*W;
P := P+H*2;
H := 2*H;
goto _20;
_31:
BD[2] := BD[1];
OM[1] := 0;
goto _14;
_32:
J1 := J1*W;
E1 := E1*W;
if (  not ( (NI) ) ) 
 then goto _33;
BA := B;
B := A;
A := BA;
_33:
if (  not ( (MI) ) ) 
 then goto _34;
ALFA := ALFA*W+A;
BETA := BETA*W+A;
_34:
case U of
 1: goto _39;
 2: goto _44;
end;
_35:
IL := 1;
J := B;
L := A;
E2 := E;
E := 1000;
_36:
B := L+V*X;
if ( (B-J)*X ) < 0
 then goto _38
 else if ( (B-J)*X ) > 0
       then goto _37
       else goto _38;
_37:
B := J;
_38:
U := 1;
goto _8;
_39:
RINT := J1;
Q := Abs(J1);
E3 := E1;
_40:
Z := False;
_41:
R := Q;
A := B;
B := L+(B-L)*V;
if ( (B-J)*X ) < 0
 then goto _43
 else if ( (B-J)*X ) > 0
       then goto _42
       else goto _43;
_42:
B := J;
_43:
U := 2;
goto _8;
_44:
RINT := RINT+J1;
Q := Abs(J1);
E3 := E3+E1;
if ( Q  = 0.  ) and ( R  = 0.0 ) 
 then goto _48;
_45:
if ( Q-0.999999*R ) < 0
 then goto _46
 else if ( Q-0.999999*R ) > 0
       then goto _40
       else goto _40;
_46:
S := Q/R;
S := Q*S/(1-S);
if ( S-E2 ) < 0
 then goto _47
 else if ( S-E2 ) > 0
       then goto _40
       else goto _40;
_47:
if (  not ( (Z) ) ) 
 then goto _55;
E3 := E3+S;
_48:
BB := E*(1+Abs(RINT));
if ( E3-BB ) < 0
 then goto _56
 else if ( E3-BB ) > 0
       then goto _49
       else goto _56;
_49:
if ( IL-1 ) < 0
 then goto _50
 else if ( IL-1 ) > 0
       then goto _50
       else goto _51;
_50:
BC := Abs(RINT-RINT2);
if ( BC-BB ) < 0
 then goto _53
 else if ( BC-BB ) > 0
       then goto _51
       else goto _53;
_51:
RINT2 := RINT;
IL := 2;
EPS := EPS/IntPower(2,7);
if ( XA+SYS059 ) < 0
 then goto _52
 else if ( XA+SYS059 ) > 0
       then goto _56
       else goto _52;
_52:
if ( EPS-SYS059 ) < 0
 then goto _53
 else if ( EPS-SYS059 ) > 0
       then goto _54
       else goto _53;
_53:
E3 := BC;
goto _56;
_54:
A := L;
goto _36;
_55:
Z := True;
goto _41;
_56:
if ( (B  < ALFA  ) and ( X  = 1)  ) or ( (B  > BETA  ) and ( X  = (-1))
 ) 
 then goto _45;
E := E2;
A := L;
B := J;
C := C+RINT;
D := C;
if ( Y ) 
 then goto _59;
if ( X+1 ) < 0
 then goto _57
 else if ( X+1 ) > 0
       then goto _58
       else goto _57;
_57:
T := E3;
M := B;
B := K;
X := 1;
goto _35;
_58:
E3 := E3+T;
A := M;
E := 2*E;
_59:
E1 := E3;
RINT := D;
if (  not ( (NIS) ) ) 
 then goto _60;
RINT := -RINT;
_60:
end;

end.
